<?php
/*
	Copyright(c) 2010 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (LIB_PATH.'/common/unitCommon.php');
class extPdf extends unitCommon
{	
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "extunit_extpdf"; //公開用テーブル名
	var $_tmptable = "extunit_extpdf_tmp"; //下書き用テーブル名 //必ず公開用テーブル名のうしろに_tmpをつけてください
	var $columns = array(
					array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//
					array("column"=>"bpdf_pdf","conv"=>"a","tags"=>false),		//ファイル名
					array("column"=>"bpdf_ttl","conv"=>"KV","tags"=>false),		//タイトル（リンクテキスト）
					array("column"=>"bpdf_dsp_flg","conv"=>"n","tags"=>false),	//ダウンロードガイド表示フラグ　0：非表示　1：表示
					array("column"=>"btm_padding","conv"=>"n","tags"=>false)	//下方スペース
					);
	var $_data = array();
	var $_filepath = null;
	//ファイル保存先
	//UNITS_UPFILES_PATHを廃止、以下に変更
	///global-image/units/upfiles/secure/

					
	function extPdf()
	{
		$this->__construct();
	}
	
	function __construct()
	{
		unitCommon::__construct();
		$this->_filepath = UNITS_UPFILES_PATH.'secure/';
	}
	//-----------------
	
	//出力データセット処理（必須）
	function setDisplayData() {
		$this->_data = $this->getDetail();
		if ($this->_data) {
			//パス
			$this->_data['path'] = $this->_filepath.$this->_data['bpdf_pdf'];
			$this->_data['size'] = $this->fsizeH(BASE_PATH.$this->_filepath.$this->_data['bpdf_pdf']);
		}
		return $this->_data;
	}
	
	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
		$rtn =  null;
		$sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);
			$rtn = $result->fetchRow(DB_FETCHMODE_ASSOC);
		}
		return $rtn;
	}
	
	
	function setDefault()
	{
		$data = $this->getDetail();
		$this->_form->setDefaults($data);
		if ($data['bpdf_pdf']) {
			$this->_view->assign('image', $this->_filepath.$data['bpdf_pdf']);
		}
	}
	
	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
		$this->_form->addElement('hidden','bpdf_pdf', null,array("id"=>"bpdf_pdf"));
		$this->_form->addElement('file', 'pdf', '');//PDFファイルアップ用ボタン
		$this->_form->addElement('text','bpdf_ttl', null, array('id'=>'bpdf_ttl','size'=>40,'maxlength' => 40));
		$this->_form->addElement('checkbox', 'bpdf_dsp_flg', null, 'Adobe&reg;&nbsp;Reader&reg;のダウンロードガイドを表示する', null, array("id"=>"bpdf_dsp_flg"));//advcheckbox  array('not checked','checked') $def_vals['bpdf_dsp_flg'] = "checked";
	}
	
	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings('下記の項目が不正です。','');		
		$this->_form->addRule('pageu_code','・「ユニットコード」が不明です。コンテンツ管理よりやり直してください','required',null,$this->erchk);
		$obj = $this->_form->getElement("bpdf_pdf");
		if (!$obj->getValue()) {
			$this->_form->addRule('pdf','・PDFファイルを選択してください。','uploadedfile',null,'server');
			$this->_form->addRule('pdf', '・ファイルはPDF形式だけが登録できます', 'mimetype', array('application/pdf') );
			$this->_form->addRule('pdf',"・PDFファイルサイズが大きすぎます。<br />アップロード可能なファイルサイズは".MAX_FILE_SIZE/(1000*1000)."Mbyte未満となっております。",'maxfilesize',MAX_FILE_SIZE,null,'server');
		}
		$this->_form->addRule('bpdf_ttl','・リンクテキストを入力してください。','required',null,$this->erchk);
	}
	
	//データ下書き保存処理
	function doSave($post)
	{
		$result = null;
		$bpdf = '';
		//既存データがあるか確認（画像削除用にも使用）
		$old_data = $this->getDetail();
		
		//PDFがアップロードされいてる場合の処理
		if (is_uploaded_file($_FILES['pdf']["tmp_name"])) {
			//拡張子チェック
			$filetypename = substr($_FILES['pdf']["name"], -4, 4);
			if($filetypename != '.pdf') {
				return $filetypename."・pdfファイルではありません。";
			}
			//ファイル名
			$bpdf = $this->_pageu_code.'-'.date("YmdHis");

			//ファイル保存用ディレクトリ
			$path = BASE_PATH.$this->_filepath;
			if (!is_dir($path)) {
				if (!mkdir($path, 0777)) {
					return "・保存先ディレクトリがありません";
				}
			}
			
			//PDFファイル保存
			$img = $this->_form->getElement('pdf');
			$bpdf = commonFile::uploadImage($img, $path, $bpdf);
			if (!$bpdf) {
				return "・PDFの保存に失敗しました";
			}
			/*if (is_file($path.'/'.$old_data['bpdf_pdf'])) {
				//旧ファイルを削除
				unlink($path.'/'.$old_data['bpdf_pdf']);
			}*/
		}
		
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			} else {
				$record[$val["column"]] = null;
			}
		}
		//ファイル名も保存
		if ($bpdf) {
			$record["bpdf_pdf"] = $bpdf;
		}
		
		//既存データがあるか確認
		$old_data = $this->getDetail();
		$this->db->query('BEGIN');
		//保存処理開始
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		}
		$this->db->query('COMMIT');
		return null;
	}
	
	function fsizeH($filepath) {
		if (!file_exists($filepath)) {
			return 'サイズ不明';
		}
		$size = filesize($filepath);
		if ($size >= 1024 && $size < 1048576) {
			$size = round($size/1024,1) .'ＫＢ';
		} elseif ($size >= 1048576) {
			$size = round($size/1048576,1) .'ＭＢ';
		} else {
			$size = $size.'Ｂ';
		}
		return $size;
	}
}


?>