<?php

/*
 * ユニットが持つテーブルの生成を行う
  * @param tbl_unitのマスタ情報
  * テーブル名は extunit_○○○○（拡張ユニットのフォルダ名）とする
 */
function extunit_install($param, $db) {
	$sql[] = 'DROP TABLE IF EXISTS extunit_extpdf CASCADE;';
	$sql[] = 'DROP TABLE IF EXISTS extunit_extpdf_tmp CASCADE;';

	switch(DBTYPE) {
		case 'pgsql':
				$sql[] = 'CREATE TABLE extunit_extpdf (
					pageu_code		integer,
					bpdf_pdf		text,
					bpdf_ttl		text,
					bpdf_dsp_flg	smallint default 1,
					bg_color		smallint default 0,
					bdr_type		smallint default 0,
					btm_padding		smallint default 2,
					primary key (pageu_code)
				);';
				$sql[] = 'CREATE TABLE extunit_extpdf_tmp (
					pageu_code		integer,
					bpdf_pdf		text,
					bpdf_ttl		text,
					bpdf_dsp_flg	smallint default 1,
					bg_color		smallint default 0,
					bdr_type		smallint default 0,
					btm_padding		smallint default 2,
					primary key (pageu_code)
				);';
			break;
			
			case "mysql":
				$sql[] = 'CREATE TABLE extunit_extpdf (
					pageu_code		integer,
					bpdf_pdf		text,
					bpdf_ttl		text,
					bpdf_dsp_flg	smallint default 1,
					bg_color		smallint default 0,
					bdr_type		smallint default 0,
					btm_padding		smallint default 2,
					primary key (pageu_code)
				)TYPE = InnoDB;';
				$sql[] = 'CREATE TABLE extunit_extpdf_tmp (
					pageu_code		integer,
					bpdf_pdf		text,
					bpdf_ttl		text,
					bpdf_dsp_flg	smallint default 1,
					bg_color		smallint default 0,
					bdr_type		smallint default 0,
					btm_padding		smallint default 2,
					primary key (pageu_code)
				)TYPE = InnoDB;';
			break;
		default:
			return false;
			break;
	}
	//sqlの実行
	if(!is_array($sql)||!count($sql)>0) {
		//テーブルのないモジュール、ユニットは存在させない
		return false;
	}
	foreach($sql as $key => $val) {
		if(!$db->query($val)) {
			return false;
		}
	}
	return true;
}
?>